<template lang='pug'>
  v-layout(row wrap justify-center)
    v-flex.pl-1.pr-3(xs6)
      v-toolbar(dark dense color="info")
        v-toolbar-title.white--text HTML
        v-spacer
        v-tooltip(bottom)
          v-btn(icon slot="activator" @click="toClipboard('html')")
            v-icon content_copy
          span copy
        v-tooltip(bottom)
          v-btn(icon slot="activator" @click="clear('html')")
            v-icon clear
          span clear
      v-divider
      editor(v-model="html" @init="editorInit" v-on:focus="activate('html')" v-on:input='html2pug' lang="html" theme="chrome" width="100%" height="100%")
    v-flex.pr-1.pl-3(xs6)
      v-toolbar(dark dense color="info")
        v-toolbar-title.white--text PUG
        v-spacer
        v-tooltip(bottom)
          v-btn(icon slot="activator" @click="toClipboard('pug')")
            v-icon content_copy
          span copy
        v-tooltip(bottom)
          v-btn(icon slot="activator" @click="clear('pug')")
            v-icon clear
          span clear
      editor(v-model="pug" @init="editorInit" v-on:focus="activate('pug')" v-on:input='pug2html' lang="jade" theme="chrome" width="100%" height="100%")    
</template>

<script>
// eslint-disable-next-line
import { clipboard } from 'electron';

import EditorComponent from './Editor';

const pug = require('pug');
const html2pug = require('html2pug');
const html2jade = require('html2jade');

export default {
  name: 'welcome',
  data() {
    return {
      html: '',
      pug: '',
      active: 'html',
    };
  },
  components: {
    editor: EditorComponent,
  },
  methods: {
    activate(value) {
      this.active = value;
    },
    clear(lang) {
      if (lang === 'html') {
        this.html = '';
      } else if (lang === 'pug') {
        this.pug = '';
      }
    },
    toClipboard(lang) {
      if (lang === 'html') {
        clipboard.writeText(this.html);
      } else if (lang === 'pug') {
        clipboard.writeText(this.pug);
      }
    },
    html2pug() {
      if (this.active === 'html') {
        html2jade.convertHtml(this.html, {
          bodyless: true,
        }, (err, jade) => {
          this.pug = jade;
        });
      }
    },
    pug2html() {
      if (this.active === 'pug') {
        this.html = pug.render(this.pug, {
          pretty: true,
        }).trim();
      }
    },
    editorInit() {
      require('brace/mode/html');
      require('brace/mode/jade');
      require('brace/theme/chrome');
    },
  },
};
</script>

<style lang='scss' scoped>

.input-group {
  height: 100%;
}

.centered {
  display: flex;
  justify-content: center;
  align-items: center;
}

.logo {
  max-width: 100%;
}

.link-btn {
  width: 150px;
}
</style>
